function wayPoints = getPath(adj, X, Y, node_start, node_goal)

% Retrieves path in terms of nodes in order of traversal
[path] = astar_voronoi2(adj, X, Y, node_start, node_goal);
wayPoints = [X(path,1) Y(path,1)];
% Plotte pathen
plot(wayPoints(:,1), wayPoints(:,2))
wayPoints = removeAlmostColinear(wayPoints,5);
plot(wayPoints(:,1), wayPoints(:,2))

%Check if path is legal (check clearance constraint). Recalculate path if
%needed
count = 1;
while (1 == 1)
    WP1 = wayPoints(count,:);
    WP2 = wayPoints(count+1,:);
    [~, ~, legal] = isPathLegal(WP1, WP2);
    if (legal == 0)
        [~,index1]=ismember(WP1,wayPoints,'rows');
        [~,index2]=ismember(WP2,wayPoints,'rows');
        % route cant be used
        adj(path(index1),path(index2)) = 0;
        adj(path(index2),path(index1)) = 0;
        % restart astar
        [path] = astar_voronoi2(adj, X, Y, node_start, node_goal);
        wayPoints = [X(path,1) Y(path,1)];
        wayPoints = removeAlmostColinear(wayPoints,5);
        
        WP1 = wayPoints(1,:);
        WP2 = wayPoints(2,:);
    else
        count = count + 1;
    end

    if (WP2 == wayPoints(size(wayPoints,1),:))
        % Path is collision free
        break
    end
end

% remove unnecessary waypoints
wayPoints = waypointReduction(wayPoints);

end