function [WP, targX, targY]  = BINN(eta, wayPoints, flag)
    persistent W
    persistent A
    persistent ups
    persistent z_old
    persistent N
    persistent nodeNrTarget
    persistent X
    persistent Y
    persistent y
    persistent x
    persistent count
    persistent finalTargetX
    persistent finalTargetY
    persistent A2
    
    dT = 0.01;
    WP = [0;0];
    
    %NN parameters
    Gamma  = 70;
    a      = 70; %A
    bu     = 1.0;
    bl     = 1.0;
    mu     = 1.0;
    lambda_weight = 0.1;
    alpha = atan2(wayPoints(1,2)-wayPoints(1,1), wayPoints(2,2)-wayPoints(2,1));
    R = [cos(alpha) -sin(alpha); sin(alpha) cos(alpha)]; % 
    y_w = sqrt((wayPoints(1,1)-wayPoints(1,2))^2+(wayPoints(2,1)-wayPoints(2,2))^2);
    persistent gridSizeX
    gridSizeX = 1;
    persistent gridSizeY
    gridSizeY = 4;
    m = ceil(y_w/gridSizeY);
    n = ceil(x_w/gridSizeX);

if flag == 0
    count = 1;
    
    % find center coordinates of nodes
    target_x = 1;
    target_y = 1;

tempMinGoal = x_w;
finalTargetX = 0;
finalTargetY = 0;
if (mod(n,2) == 0)
    x = zeros(m+1,n+1);
    y = zeros(m+1,n+1);
    P = zeros(m+1,n+1,2);
    N = (m+1)*(n+1);
    for i = 1:m+1
        for j = 1:n+1
            x(i,j) = (j-1-(n/2))*gridSizeX;
            y(i,j) = (i-1)*gridSizeY;
            P(i,j,:) = [wayPoints(1,1) ;wayPoints(2,1)] + R'*[x(i,j); y(i,j)];
            distGoal = sqrt((P(i,j,1)-wayPoints(1,2))^2+(P(i,j,2)-wayPoints(2,2))^2);
            if (distGoal <= tempMinGoal)
                finalTargetX = P(i,j,1);
                finalTargetY = P(i,j,2);
                tempMinGoal = distGoal;
                target_x = i;
                target_y = j;
            end
        end
    end
else
    x = zeros(m,n);
    y = zeros(m,n);
    N = m*n;
    P = zeros(m,n,2);
    for i = 1:m
        for j = 1:n
            x(i,j) = (j-1-((n-1)/2))*gridSizeX;
            y(i,j) = (i-1)*gridSizeY;
            P(i,j,:) = [wayPoints(1,1) ;wayPoints(2,1)] + R'*[x(i,j); y(i,j)];
            distGoal = sqrt((P(i,j,1)-wayPoints(1,2))^2+(P(i,j,2)-wayPoints(2,2))^2);
            if (distGoal <= tempMinGoal)
                finalTargetX = P(i,j,1);
                finalTargetY = P(i,j,2);
                tempMinGoal = distGoal;
                target_x = i;
                target_y = j;
            end
        end
    end
end

X = reshape(x,[1,N]);
Y = reshape(y,[1,N]);


A = zeros(N,N); % Adjacency matrix
W = zeros(N,N); % Weight matrix
A2 = zeros(N,N);


for i=1:N
    for j=1:N
        dist = sqrt((X(j)-X(i))^2+(Y(j)-Y(i))^2);
        if (i ~= j) && (dist <= gridSizeY*1.001)
            if (abs(Y(j)-Y(i)) < 0.05)
                if (dist < gridSizeX*1.1)
                    A(i,j) = 1;
                    W(i,j) = gridSizeX*mu/dist;
                end
            else
                A(i,j) = 1;
                W(i,j) = gridSizeX*mu/dist;
            end
                
        end
        
        if (i ~= j) && (dist <= sqrt(gridSizeY^2+gridSizeX^2)*1.001)
            if (abs(Y(j)-Y(i)) < 0.05)
                if (dist < gridSizeX*1.1)
                    A2(i,j) = 1;
                end
            else
                A2(i,j) = 1;
            end
                
        end
    end
end


   X = reshape(P(:,:,1),[1,N]);
   Y = reshape(P(:,:,2),[1,N]);
    z_old = zeros(size(X));
    z_new = z_old;

   
    

    
    %% neural activity matrix
    UPS   = zeros(size(x));
    ObstacleIdx = zeros(N,2);
    [No,N2] = size(ObstacleIdx);

    ii = 1;

    
    rectB = [9, 1.5, 2, 2];

    for i = 1:m
        for j = 1:n
            north = P(i,j,1);
            east = P(i,j,2);
            
                
            rectA = [east-gridSizeX/2, north-gridSizeY/2, gridSizeX, gridSizeY];
            
            if (rectint(rectA,rectB) ~= 0)   
                ii = ii + 1;
            end
        end
    end
    
    %% fills ups with activity -gamma for obstacles
    for i=1:No
        if (ObstacleIdx(i,:) ~= 0)
            UPS(ObstacleIdx(i,1),ObstacleIdx(i,2)) = -Gamma;
        end
    end
    
    TargetIdx = [ target_x, target_y ]; % 1 final target
    
    [Nt,N2] = size(TargetIdx);
    % set activity level for targets
    for i=1:Nt
        UPS(TargetIdx(1),TargetIdx(2)) =Gamma; %multiply lambda to prioritize
        %     UPS(TargetIdx(i,1),TargetIdx(i,2)) = -Gamma;
    end
    
    ups = reshape(UPS,[N,1]);
    
    for k = 1:50  % Simulation loop
        for i=1:N
            ups_p = max(0,ups(i)); % target
            ups_m = max(0,-ups(i)); % obstacle
            excite = 0.0;
            [~,col] = find(A(i,:));
            for jj=1:length(col)
                z_p    = max(0,z_old(col(jj)));
                %             z_m    = max(0,-z_old(col(jj)));
                excite = excite + W(i,col(jj))*z_p;
                %             excite = excite + W(i,col(jj))*z_m;
            end
            z_new(i) = z_old(i) + dT*(-a*z_old(i)-(z_old(i)-bu)*(ups_p+excite)-(z_old(i)+bl)*ups_m);
            %         z_new(i) = z_old(i) + dT*(-a*z_old(i)-(z_old(i)+bl)*(ups_m+excite)-(z_old(i)-bu)*ups_p);
        end
        z_old = z_new;
    end
    
   %evolved neural activity
%     Z  = reshape(z_old,[m+1,n+1]);
%     Y2  = reshape(Y,[m+1,n+1]);
%     X2  = reshape(X,[m+1,n+1]);
%     surf(Y2,X2,Z); xlabel('y'); ylabel('x'); zlabel('Activity level [-]');
%     disp(Z);
    tempMin = x_w;
    indexClosest = 0;
    for i = 1:length(X)
        distClosest = sqrt((eta(1)-X(i))^2+(eta(2)-Y(i))^2);
        if distClosest < tempMin
            tempMin = distClosest;
            indexClosest = i;
        end
    end
    nodeNrTarget = indexClosest;
    
    [~,col] = find(A2(nodeNrTarget,:)); %
    tempMaxFirst =-1000;
    % find node number of neighbour with maximum activity level
    for jj=1:length(col)
        theta_j = atan2(Y(col(jj))-Y(indexClosest), X(col(jj))-X(indexClosest));
        theta_q = eta(3);
        smallest_angle_diff = abs(rad2radpi(theta_j-theta_q));
        if (((1-(smallest_angle_diff/pi))*(z_old(col(jj))*lambda_weight)+(1-lambda_weight)*z_old(col(jj))) > tempMaxFirst)
            tempMaxFirst = (1-(smallest_angle_diff/pi))*(z_old(col(jj))*lambda_weight)+(1-lambda_weight)*z_old(col(jj));
            nodeNrTarget = col(jj);
        end
    end

    
    xtarget = X(nodeNrTarget);
    ytarget = Y(nodeNrTarget);
%     disp(target_x);
%     disp(target_y);
    

  
else
    %% Evolving NN dynamics
    
    if (isempty(count))
        count = 1;
    else
        count = count +1;
    end
    if (isempty(ups))
        ups = 1;
    end

    if isempty(A)
        A = 1;
    end
    
    if isempty(A2)
        A2 = 1;
    end
    
    if isempty(z_old)
        z_old = 1;
    end
    
    if isempty(finalTargetX)
        finalTargetX = 1;
    end
    
    if isempty(finalTargetY)
        finalTargetY = 1;
    end
    if isempty(W)
        W = 1;
    end
    
    if isempty(nodeNrTarget)
        nodeNrTarget = 1;
    end
    
    if isempty(X)
        X = 1;
    end
    
    if isempty(Y)
        Y = 1;
    end
    if isempty(N)
        N = 1;
    end
    z_new = zeros(1,N);

    if (1 == 1)
        for i=1:N
            ups_p = max(0,ups(i));
            ups_m = max(0,-ups(i));
            excite = 0.0;
            [~,col] = find(A(i,:));
            for jj=1:length(col)
                z_p    = max(0,z_old(col(jj)));
                %                 z_m    = max(0,-z_old(col(jj)));
                excite = excite + W(i,col(jj))*z_p;
                %                 excite = excite + W(i,col(jj))*z_m;
            end
            z_new(i) = z_old(i) + dT*(-a*z_old(i)-(z_old(i)-bu)*(ups_p+excite)-(z_old(i)+bl)*ups_m);
            %             z_new(i) = z_old(i) + dT*(-a*z_old(i)-(z_old(i)+bl)*(ups_m+excite)-(z_old(i)-bu)*ups_p);
        end
        z_old = z_new;
        count = 0;
    end
firstTarget = nodeNrTarget;
% finner (x,y) koord til naboer med adj matrix
[~,col] = find(A2(nodeNrTarget,:)); %
tempMaxFirst =-1000;
% find node number of neighbour with maximum activity level
for jj=1:length(col)
    theta_j = atan2(Y(col(jj))-Y(firstTarget), X(col(jj))-X(firstTarget));
    theta_q = eta(3);
    smallest_angle_diff = abs(rad2radpi(theta_q-theta_j));
    if (((1-(smallest_angle_diff/pi))*(z_old(col(jj))*lambda_weight)+(1-lambda_weight)*z_old(col(jj))) > tempMaxFirst)
        tempMaxFirst = (1-(smallest_angle_diff/pi))*(z_old(col(jj))*lambda_weight)+(1-lambda_weight)*z_old(col(jj));
        nodeNrTarget = col(jj);
    end
end


xtarget = X(nodeNrTarget);
ytarget = Y(nodeNrTarget);
z_old(nodeNrTarget) = 0;
z_old(firstTarget) = 0;

    % evolved neural activity
%     Z  = reshape(z_old,[m,n]);
%     surf(y,x,Z); xlabel('y'); ylabel('x');
%        
    
end

% finalTarget = [finalTargetX; finalTargetY];
targX = finalTargetX;
targY = finalTargetY;
WP = [xtarget; ytarget];
%  % evolved neural activity
%     Z  = reshape(z_old,[target_x,target_y]);
%     surf(y,x,Z); xlabel('y'); ylabel('x');
end
