load('CSAD_model.mat'); % loads "vessel"
load('CSAD_modelABC.mat'); % loas "vesselABC"

%% Define initial conditions
tstart = 0;
tstop = 300; % simulation time in seconds


init_K1 = [1 0 0; 0 1 0; 0 0 0.7]*0.05;
init_K2 =  [8 0 0; 0 8 0; 0 0 2]*12.45;

eta_0 = [0 0 0 0 0 0]; % Initial position in origin
nu_0 = [0 0 0 0 0 0]; % Initial velocity 0

%wayPoints = [0 7.8 17.38 19.96 25.22 25.22 30; 12 5.6 8.3 13.3 18.7 23.84 30];
wayPoints = [0 7.75 32.5 50;0 24.4 43.4 50];
%wayPoints = [0 20 18 5 20; 0 10 15 20 25];
Lx1 =  1.0678;   Ly1 =  0.0;
Lx2 =  0.9344;   Ly2 =  0.11;
Lx3 =  0.9344;   Ly3 = -0.11;
Lx4 = -1.1644;   Ly4 =  0.0;
Lx5 = -0.9911;   Ly5 = -0.1644;
Lx6 = -0.9911;   Ly6 =  0.1644;

K_e1 = 1.491*diag([1,1,1,1,1,1]);
alpha = [pi pi/4 -pi/4 0 5*pi/4 3*pi/4]';
L = [Lx1 norm([Lx2 Ly2]) norm([Lx3 Ly3]) norm([Lx4 Ly4]) norm([Lx5 Ly5]) norm([Lx6 Ly6])];
v1 = [0 atan(Ly2/Lx2) atan(Ly3/Lx3) 0 atan(Ly5/Lx5) atan(Ly6/Lx6)];

T_m = [cos(alpha)'; sin(alpha)'; cos(v1).*sin(alpha)'.*L];
T_m(3,5)=-T_m(3,5);
T_m(3,6)=-T_m(3,6);

T = T_m*K_e1;
%nedskalering av sway force og yaw moment
T(2,2) = 0.95*T(2,2);
T(2,3) = 0.95*T(2,3);
T(2,5) = 0.95*T(2,5);
T(2,6) = 0.95*T(2,6);
T(3,2) = 0.85*T(2,2);
T(3,3) = 0.85*T(2,3);
T(3,5) = -0.85*T(2,5);
T(3,6) = -0.85*T(2,6);

T_pinv_m = pinv(T);


