function [x_d_n, y_d_n, x_d_theta_n, y_d_theta_n, x_d_theta2_n, y_d_theta2_n, psi_d_n,...
 psi_d_theta_n, psi_d_theta2_n, v_s_n, v_s_theta_n] = path_generation(wayPoints, u_d, lambda)
% INPUT waypoints
X_wp = [wayPoints(1,:)];
Y_wp = [wayPoints(2,:)];
r           = 3;    % Differentiability order.
% Run scripts
WP = [X_wp' Y_wp'];
N  = 1;

t0 = WP(2,:)-WP(1,:);

linSysA = zeros(8,8,N);
Order = zeros(1,1,N);
NumSubpaths = zeros(1,1,N);
linSysbx = zeros(8,1,N);
linSysby = zeros(8,1,N);
Wpx = zeros(2,1,N);
Wpy = zeros(2,1,N);
coeff_a = zeros(8,1,N);
coeff_b = zeros(8,1,N);
coeff_a_der = zeros(7,7,N);
coeff_b_der = zeros(7,7,N);

for j=1:1
    p0 = WP(2,:);
    pt = WP(3,:);
    [NumSubpaths(:,:,j), Order(:,:,j), linSysA(:,:,j), linSysbx(:,:,j), ...
        linSysby(:,:,j), Wpx(:,:,j), Wpy(:,:,j), coeff_a(:,:,j),...
        coeff_b(:,:,j), coeff_a_der(:,:,j), coeff_b_der(:,:,j)]= ...
        GenerateOnlinePathSegmentwithoutStruct(p0,pt,t0,r,lambda,1);
 %   t0 = WP(j+1,:)-WP(j,:);
end

s = [0:.01:N-0.01];
pd_der = zeros(length(s),2,Order(1,1,1));
pd = zeros(length(s),2);
for k=1:Order(1,1,1)
        for j=1:length(s)
            ii    = floor(s(j)) + 1;
            theta = s(j) - ii + 1;
            [pd_curr, pd_der_curr] = GetHybridPathSignalswithoutStruct(theta, ...
                NumSubpaths(:,:,ii), Order(:,:,ii), linSysA(:,:,ii), ...
                linSysbx(:,:,ii), linSysby(:,:,ii), Wpx(:,:,ii),...
                Wpy(:,:,ii), coeff_a(:,:,ii), coeff_b(:,:,ii), ...
                coeff_a_der(:,:,ii), coeff_b_der(:,:,ii));
            
            pd_der(j,:,k) = pd_der_curr(:,:,k);
            %PS = GetHybridPathSignals(Path{ii},theta);
            pd(j,:) = pd_curr;
        end
end


%pd = reshape(pd,length(s)/N,N);
x_d = pd(:,1);
y_d = pd(:,2);
% 
hold on
plot(y_d,x_d);
xlabel('East'); ylabel('North');
x_d_theta = pd_der(:,1,1);
y_d_theta = pd_der(:,2,1);


x_d_theta2 = pd_der(:,1,2);
y_d_theta2 = pd_der(:,2,2);



%syntax: variable_derivativeorder
% each segment placed in corresponding column
psi_d = atan2( pd_der(:,2,1),pd_der(:,1,1));

psi_d_theta = ((pd_der(:,1,1).*pd_der(:,2,2))-(pd_der(:,1,2).*pd_der(:,2,1)))./...
(pd_der(:,1,1).^2 + pd_der(:,2,1).^2);

psi_d_theta2 = (((pd_der(:,1,1).*pd_der(:,2,3))-(pd_der(:,1,3).*pd_der(:,2,1)))./...
(pd_der(:,1,1).^2 + pd_der(:,2,1).^2))-2*(((pd_der(:,1,1).*pd_der(:,2,2))...
-(pd_der(:,1,2).*pd_der(:,2,1))).*((pd_der(:,1,1).*pd_der(:,1,2))+...
(pd_der(:,2,1).*pd_der(:,2,2)))./(((pd_der(:,1,1).^2)+(pd_der(:,2,1).^2)).^2));


v_s_theta = (pd_der(:,1,1).*pd_der(:,1,2))+(pd_der(:,2,1).*pd_der(:,2,2));
v_s = zeros(length(s),1);
for i = 1:length(s)
%disp(sqrt(pd_der(i,1,1)^2 + pd_der(i,2,1)^2))
    
%         v_s(i) = u_d / sqrt(pd_der(i,1,1)^2 + pd_der(i,2,1)^2);
%         v_s_theta(i) = -u_d*v_s_theta(i)/(sqrt(pd_der(i,1,1)^2 + pd_der(i,2,1)^2)^3);
        
        v_s(i) = u_d / sqrt(pd_der(i,1,1)^2 + pd_der(i,2,1)^2);
        v_s_theta(i) = -u_d*v_s_theta(i)/(sqrt(pd_der(i,1,1)^2 + pd_der(i,2,1)^2)^3);
    
end

nRows = length(s)/N;
nCols = N;
count = 1;
x_d_n = zeros(nRows,nCols);
y_d_n = zeros(nRows,nCols);
x_d_theta_n = zeros(nRows,nCols);
y_d_theta_n = zeros(nRows,nCols);
x_d_theta2_n = zeros(nRows,nCols);
y_d_theta2_n = zeros(nRows,nCols);
psi_d_n = zeros(nRows,nCols);
psi_d_theta_n = zeros(nRows,nCols);
psi_d_theta2_n = zeros(nRows,nCols);
v_s_n = zeros(nRows,nCols);
v_s_theta_n = zeros(nRows,nCols);
for i = 1:nCols
    for j = 1:nRows
        x_d_n(j,i) = x_d(count);
        y_d_n(j,i) = y_d(count);
        x_d_theta_n(j,i) = x_d_theta(count);
        y_d_theta_n(j,i) = y_d_theta(count);
        x_d_theta2_n(j,i) = x_d_theta2(count);
        y_d_theta2_n(j,i) = y_d_theta2(count);
        psi_d_n(j,i) = psi_d(count);
        psi_d_theta_n(j,i) = psi_d_theta(count);
        psi_d_theta2_n(j,i) = psi_d_theta2(count);
        v_s_n(j,i) = v_s(count);
        v_s_theta_n(j,i) = v_s_theta(count);
        
        count = count+1;
    end
end


end